import * as fs from 'graceful-fs';
import Promise = require('native-or-bluebird');
import lockfile = require('lockfile');
import tch = require('touch');
import { ConfigJson } from '../interfaces/main';
import { CompiledOutput } from '../lib/compile';
export declare type Stats = fs.Stats;
export declare const touch: (a: string, b: tch.Options) => Promise<{}>;
export declare const stat: (a: string) => Promise<fs.Stats>;
export declare const readFile: (a: string, b: string) => Promise<string>;
export declare const writeFile: (a: string, b: string | Buffer) => Promise<void>;
export declare const mkdirp: (a: string) => Promise<void>;
export declare const unlink: (a: string) => Promise<void>;
export declare const lock: (a: string, b: lockfile.Options) => Promise<void>;
export declare const unlock: (a: string) => Promise<{}>;
export declare const rimraf: (a: string) => Promise<{}>;
export declare function isFile(path: string): Promise<boolean>;
export declare function readJson(path: string): Promise<any>;
export declare function writeJson(path: string, json: any, indent?: string | number, eol?: string): Promise<void>;
export declare function readConfig(path: string): Promise<ConfigJson>;
export declare function readConfigFrom(path: string): Promise<ConfigJson>;
export declare function parseConfig(config: ConfigJson, path: string): ConfigJson;
export declare function readHttp(url: string): Promise<string>;
export declare function readFileFrom(from: string): Promise<string>;
export declare function readJsonFrom(from: string): Promise<any>;
export declare function stringifyJson(json: any, indent?: number | string, eol?: string): string;
export declare function parseJson(contents: string, path: string): any;
export declare function transformFile(path: string, transform: (contents: string) => string | Promise<string>): Promise<void>;
export declare function transformJson<T>(path: string, transform: (json: T) => T): Promise<void>;
export declare function transformConfig(cwd: string, transform: (config: ConfigJson) => ConfigJson): Promise<void>;
export declare function transformDtsFile(path: string, transform: (typings: string[]) => string[]): Promise<void>;
export interface DefinitionOptions {
    cwd: string;
    name: string;
    ambient: boolean;
}
export declare function writeDependency(output: CompiledOutput, options: DefinitionOptions): Promise<CompiledOutput>;
export declare function removeDependency(options: DefinitionOptions): Promise<any>;
export declare function getTypingsLocation(options: {
    cwd: string;
}): {
    typingsDir: string;
    mainDtsFile: string;
    browserDtsFile: string;
};
export declare function getDependencyLocation(options: DefinitionOptions): {
    mainFile: string;
    browserFile: string;
    mainPath: string;
    browserPath: string;
    mainDtsFile: string;
    browserDtsFile: string;
};
